<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ProposalRequestProcessor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">ProposalRequestProcessor.java</span></div><h1>ProposalRequestProcessor.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.RequestProcessor;
import org.apache.zookeeper.server.SyncRequestProcessor;
import org.apache.zookeeper.server.quorum.Leader.XidRolloverException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This RequestProcessor simply forwards requests to an AckRequestProcessor and
 * SyncRequestProcessor.
 */
public class ProposalRequestProcessor implements RequestProcessor {
<span class="fc" id="L33">    private static final Logger LOG =</span>
<span class="fc" id="L34">        LoggerFactory.getLogger(ProposalRequestProcessor.class);</span>

    LeaderZooKeeperServer zks;
    
    RequestProcessor nextProcessor;

    SyncRequestProcessor syncProcessor;

    public ProposalRequestProcessor(LeaderZooKeeperServer zks,
<span class="fc" id="L43">            RequestProcessor nextProcessor) {</span>
<span class="fc" id="L44">        this.zks = zks;</span>
<span class="fc" id="L45">        this.nextProcessor = nextProcessor;</span>
<span class="fc" id="L46">        AckRequestProcessor ackProcessor = new AckRequestProcessor(zks.getLeader());</span>
<span class="fc" id="L47">        syncProcessor = new SyncRequestProcessor(zks, ackProcessor);</span>
<span class="fc" id="L48">    }</span>
    
    /**
     * initialize this processor
     */
    public void initialize() {
<span class="fc" id="L54">        syncProcessor.start();</span>
<span class="fc" id="L55">    }</span>
    
    public void processRequest(Request request) throws RequestProcessorException {
        // LOG.warn(&quot;Ack&gt;&gt;&gt; cxid = &quot; + request.cxid + &quot; type = &quot; +
        // request.type + &quot; id = &quot; + request.sessionId);
        // request.addRQRec(&quot;&gt;prop&quot;);
                
        
        /* In the following IF-THEN-ELSE block, we process syncs on the leader. 
         * If the sync is coming from a follower, then the follower
         * handler adds it to syncHandler. Otherwise, if it is a client of
         * the leader that issued the sync command, then syncHandler won't 
         * contain the handler. In this case, we add it to syncHandler, and 
         * call processRequest on the next processor.
         */
        
<span class="fc bfc" id="L71" title="All 2 branches covered.">        if(request instanceof LearnerSyncRequest){</span>
<span class="fc" id="L72">            zks.getLeader().processSync((LearnerSyncRequest)request);</span>
        } else {
<span class="fc" id="L74">                nextProcessor.processRequest(request);</span>
<span class="fc bfc" id="L75" title="All 2 branches covered.">            if (request.hdr != null) {</span>
                // We need to sync and get consensus on any transactions
                try {
<span class="fc" id="L78">                    zks.getLeader().propose(request);</span>
<span class="fc" id="L79">                } catch (XidRolloverException e) {</span>
<span class="fc" id="L80">                    throw new RequestProcessorException(e.getMessage(), e);</span>
<span class="fc" id="L81">                }</span>
<span class="fc" id="L82">                syncProcessor.processRequest(request);</span>
            }
        }
<span class="fc" id="L85">    }</span>

    public void shutdown() {
<span class="fc" id="L88">        LOG.info(&quot;Shutting down&quot;);</span>
<span class="fc" id="L89">        nextProcessor.shutdown();</span>
<span class="fc" id="L90">        syncProcessor.shutdown();</span>
<span class="fc" id="L91">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>